﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace CreaDynaRect
{
 public partial class Page : UserControl
 {
  Rectangle rc;
  bool bRectInCreation;
  Point ptUpperLeftCorner;
  public Page()
  {
   InitializeComponent();
  }

  private void LayoutRoot_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
  {
   if (rc != null) LayoutRoot.Children.Remove(rc);

   Point p = e.GetPosition(this);
   bRectInCreation = true;
   ptUpperLeftCorner = p;
  }

  private void LayoutRoot_MouseMove(object sender, MouseEventArgs e)
  {
   if (bRectInCreation)
   {
    if (rc != null) LayoutRoot.Children.Remove(rc);
    Point p = e.GetPosition(this);
    double X = Math.Min(p.X, ptUpperLeftCorner.X);
    double Y = Math.Min(p.Y, ptUpperLeftCorner.Y);
    double W = Math.Abs(p.X - ptUpperLeftCorner.X);
    double H = Math.Abs(p.Y - ptUpperLeftCorner.Y);

    rc = new Rectangle();
    rc.SetValue(Canvas.LeftProperty, X);
    rc.SetValue(Canvas.TopProperty, Y);
    rc.Width = W;
    rc.Height = H;
    rc.Fill = new SolidColorBrush(Color.FromArgb(64, 255, 0, 0));
    LayoutRoot.Children.Add(rc);
   }
  }

  private void LayoutRoot_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
  {
   if (bRectInCreation)
   {
    rc.Stroke = new SolidColorBrush(Colors.Red); rc.StrokeThickness = 1;
    rc.Fill = new SolidColorBrush(Color.FromArgb(0, 0, 0, 0));
   }
   bRectInCreation = false;
  }
 }
}
